#!/bin/sh

PATH=/sbin:/bin:/usr/bin:/usr/sbin
TMPDIR=/mnt/ramdisk
LOGFILE_TAR_GZ=${TMPDIR}/logtracker.tar.gz
VERSIONFILE=../pkgVersion.xml
VERSION=`/usr/bin/tinyxmlparser -x /tracker/version -f ${VERSIONFILE}`
TRACKER_VERSION=`/usr/bin/tinyxmlparser -x /vadp/version -f ../vadp.xml`

if [ -L $0 ] ; then
    BASEDIR=$(cd "$(dirname "$(readlink $0)")"; pwd -P) # for symbolic link
else
    BASEDIR=$(cd "$(dirname "$0")"; pwd -P) # for normal file
fi
EXE_BASE=${BASEDIR%/*}

Create_Backup_File()
{
    cd ../ || return

	[ -e "/mnt/ramdisk/Metadata.log" ] && metadataLog="/mnt/ramdisk/Metadata.log"
	[ -e "/mnt/ramdisk/TRACKER.log" ] && trackerLog="/mnt/ramdisk/TRACKER.log"
	[ -e "${EXE_BASE}/logs/" ] && flash2Log="${EXE_BASE}/logs/"
	[ -e "/mnt/flash2/trackerdb/" ] && dbLog="/mnt/flash2/trackerdb/"
	[ -e "/mnt/ramdisk/logs/" ] && ramdiskLog="/mnt/ramdisk/logs/"
	[ -e "${EXE_BASE}/calib_data/" ] && calibData="${EXE_BASE}/calib_data/"	

	tar zcf "${LOGFILE_TAR_GZ}" "${metadataLog}" "${trackerLog}" "${flash2Log}" "${dbLog}" "${ramdiskLog}" "${calibData}"
	strlog="$(wc -c ${LOGFILE_TAR_GZ} | awk '{print $1}')"
    return 0   
}

Create_Backup_File
[ $? -eq 0 ] && {
    echo -ne "Content-type: text/plain\r\n"
	echo -ne "Content-Disposition: attachment; filename=VCA-Logs-v${TRACKER_VERSION}.tar.gz\r\n"
	echo -ne "Content-length:${strlog}\r\n\r\n"
	cat $LOGFILE_TAR_GZ>&1
	rm -rf $LOGFILE_TAR_GZ
}
